package com.logicbig.example;

import static com.logicbig.example.RegexUtil.test;

public class RegexExamples {

    public static void main(String[] args) {
        test(".+?", "abc");
        test("a+?", "babaab");
        /* Comparing with Greedy + */
        test("a+", "babaab");
        test("(xyz)+?", "xyzxyz");
        test("((abc)|(xyz))+?", "abcxyz xyzabc");
        /* Comparing with Greedy + */
        test("((abc)|(xyz))+", "abcxyz xyzabc");
        test("[0-9]+?", "9823 340");
        /* Comparing with Greedy + */
        test("[0-9]+", "9823 340");
        test("d.+?o", "doodododo");

        //The Asterisk Reluctant Quantifier
        test(".*?", "");
        test(".*?", "");
        test(".*?", "maths");
        test("x*?", "xxx");
        test("x.*?", "xxx");
        test("x", "xxx");
        test("x.*?e", "xylose xylene xe ex");
        test("x.+?e", "xylose xylene xe ex");

       /* Making it greedy */
        test("x.+e", "xylose xylene xe ex");
        test("\\b\\w*?bb\\w*?\\b", "bobby blub jibb lobby abba bb");

        //The Question Mark Reluctant Quantifier:
        test(".??", "");
        test("x.??", "xxx");
        test("s.??o", "so solo silo");

       /* Replacing ? with + still keeping it reluctant */
        test("s.+?o", "so solo silo");

          /* This will also match 'My electric guitar' */
        test("My\\s+(electric)??\\s*guitar", "My guitar");

        //The Curly Brackets Reluctant Quantifier
        test(".{3,}?", "abcde");
        /* Making it Greedy */
        test(".{3,}", "abcde");
        test(".{4,}?", "abcdefghij");
        test("(\\w{3,}?\\.){2}?\\w{3,}?", "www.example.com");
        /* This matches sentences that contain between one to ten words. */
        test("[A-Z](\\w*?\\s*?){1,10}?[.?!]", "This is a paragraph. what?");
    }
}